;created 01/08/92
;updated 12/19/92

;=======================================================================
;   Copyright (C) Copr. 1992 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
;RM82TS8,16,24,32,40,48

DOSSEG
.MODEL MEDIUM, BASIC

EXTRN B$ASSN:FAR     ;This allows QBASIC to manipulate fixed length string
EXTRN B$STDL:FAR     ;This creates null strings

.DATA
	EXTRN  B$TEMPDATA:WORD       ;inside FDATA
	EXTRN  B$STRINGLEN:WORD      ;inside FDATA
	EXTRN  B$STRINGOFF:WORD      ;inside FDATA
.CODE

FullSafe EQU 1       ;toggle for conditional assembly
; if FullSafe = 1 then use safe copy to QBASIC string copy routines
; if FullSafe = 0 then use faster simple assignment routines

;============================================================================
; DECLARE FUNCTION FORMATNUMLEFT$ (NUMSTR$)
; Usage:
;     T$ = FORMATNUM$(STR$(Num%))
; Assumes:
;       number formatted by STR$ with either a leading " " or "-"
; Purpose:
; 	Formats a number$ using commas and decimal points
; Output
;       Left justifies output, w/o leading space, will show '-' sign
; Speed:
;       About 1.7 times faster than a pure QBASIC routine
;============================================================================
;
;By storing DATA in code seg, this routine cannot be used
;under OS/2.  We do it to save space in DGROUP
;---------------------------------

ASCIISpace      equ     32

; This table allows us to format from left of string rather than
; counting back from right of string
SizeTable       db      0,0,0,0,1,2,3,1,2,3,1,2,3,1,2,3,1,2,3

EVEN
Error_Exit:
	Jmp     Err_Exit        ; to make w/in short range
EVEN
FORMATNUMLEFT PROC FAR BASIC USES SI DI, NUMSTRING:PTR
	Mov     SI,NUMSTRING    ; get Num$
	Mov     CX,[SI]         ; get length of string
	JCXZ    Error_Exit      ; if zero, Error so exit
	Cmp     CX,18           ; if LEN > 18 then not a numstring
		; probably a double precision number
		; no real testing to catch everything possible
	JA      Error_Exit      ; string too long, invalid
	Mov     AX,SS
	Mov     ES,AX           ; make ES = DGROUP
;       Assume  ES:@data        ; note for programmer
	Mov     DI,OFFSET B$TEMPDATA; get address of buffer in DI
	Dec     CX              ; reduce count by leading space
	Mov     DX,CX           ; store original length in DX too
	Cld                     ; make sure direction flag is clear
	Mov     SI,[SI+2]       ; put address of first char in SI
	Lodsb                   ; get first char (DS:SI) into AL
				; either a space or a '-' sign
	Cmp     AL,ASCIISpace
	Je      @f              ; if first char is a space, don't store
	Stosb                   ; else store AL at (ES:DI)
@@:
	Jmp     Short  MAIN
FORMATNUMLEFT ENDP

;============================================================================
; DECLARE FUNCTION FORMATNUM$ (NUMSTR$)
; Usage:
;     T$ = FORMATNUM$(STR$(Num%))
; Assumes:
;       number formatted by STR$ with either a leading " " or "-"
; Purpose:
;       Formats a number$ using commas and decimal points
; Output
;       Left justifies output, w/ leading space or '-' sign
; Speed:
;       About 1.6 times faster than a pure QBASIC routine
;============================================================================

EVEN
FORMATNUM PROC FAR BASIC USES SI DI, NUMSTRING:PTR
	COMMENT		|*
------------- variable listing
 AX = used first for scratch, then
 	AL = loader area for StosB, AH = ','
 BX = first length of right side then length of left side of string
 CX = current length of print section or scan section
 DX = Overall length of string, less beginning ' ' or '-'
 SI = pointer to source string
 DI = pointer to buffer
 DS, ES = point to DGROUP
---------------
			*|
	Mov     SI,NUMSTRING    ; get Num$
	Mov	CX,[SI]         ; get length of string
	JCXZ    Err_Exit        ; if zero, Error
	Cmp     CX,18           ; if LEN > 18 then not a numstring
		; probably a double precision number
		; no real testing to catch everything possible
	JA	Err_Exit	; string too long, invalid
	Mov	AX,SS
	Mov	ES,AX		; make ES = DGROUP
;	Assume  ES:@data	; note for programmer
	Mov     DI,OFFSET B$TEMPDATA; get address of buffer in DI
	Dec     CX              ; reduce count by leading space
	Mov	DX,CX		; store original length in DX too
	Cld			; make sure direction flag is clear
	Mov	SI,[SI+2]	; put address of first char in SI
	Movsb			; store either leading '-' or ' '
MAIN::
	Push	DI		; save current DI on stack
	Mov	DI,SI		; point DI to beginning of string
	Xor     BX,BX           ; assume no period
	Mov	AL,'.'          ; load search value
; DI, CX trashed in next section
	Repne   Scasb           ; uses ES:DI to search as long as not found
	Jnz     NoPeriod        ; unless ZF then '.' not found
	Mov     BX,CX           ; put length of portion to right
				; of decimal point in BX
	Inc     BX              ; add space for '.'
NoPeriod:
	Pop     DI              ; get back offset of B$TEMPDATA
	Push	BX		; save length of right side of dp
	Mov	CX,DX		; load CX with total LEN of String
	Mov	AX,BX		; put length of right side in AX
	Sub	CX,AX		; determine length of left side
	Mov	BX,CX		; put length of left side in BX
	Xor     CH,CH           ; clear high byte
	Mov	AH,','		; pre-load comma
Looper:   ;print initial grouping ending w/ a ',' after each group
	Mov     CL,SizeTable[BX] ; determine where to put first ','
	Sub	BX,CX		; calc remaining length of left string
	JCXZ	DoRemain	; do remaining characters
	Rep	Movsb		; put CX char from DS:SI into ES:DI
	Mov	AL,AH		; put comma in AL
	Stosb			; store comma
	Jmp	Short	Looper	; start process again
DoRemain:  ;print balance w/o any ','
	Mov	CX,BX		; put remaining left side length in CX
	Rep	Movsb		; put CX char from DS:SI into ES:DI
RightSide:  ;print char at '.' and on to right (if any)
	Pop     BX              ; get length of right side back in BX
	Or	BX,BX		; is BX (right side) = 0?
	Jz	@f		; yes, so skip ahead
	Mov	CX,BX		; else store LEN of right side in CX
				; store right side starting w/ '.'
	Rep	Movsb		; put CX char from DS:SI into ES:DI
@@:
	Mov     CX,DI           ; get current offset in CX
	Mov     BX,OFFSET B$TEMPDATA ; get address of first stored char
	Sub     CX,BX           ; subtract address of last char printed

; get string into BASIC string space
;-----------
; Push Datasegment of source
; Push Offset of source
; Push LEN of source
; Push Datasegment of string descriptor
; Push Offset of descriptor
; Push 0, note that it is a variable string
;------------

CopyString:                     ; MAIN EXIT W/O ERROR

IF FullSafe
	Push    DS              ; Store the Data Segment
	Mov     AX, OFFSET B$TEMPDATA
	Push    AX              ; Store offset of string
	Push    CX              ; Store LEN of string
	Push    DS              ; Store the Data Segment
	Mov     AX, OFFSET B$STRINGLEN
	Push    AX              ; Store Descriptor of string
	Xor     AX,AX           ; tell Basic it is a variable string
	Push    AX              ; Store a 0
	Call    B$ASSN          ; copy string into BASIC space
ELSE
	Mov     DX,SS           ; put segment in DX
	Mov     B$STRINGLEN,CX  ; store length of string in descriptor
	Mov     AX, OFFSET B$TEMPDATA
	Mov     B$STRINGOFF,AX  ; store address of buffer in offset
ENDIF

Finis:
	Mov     AX, OFFSET B$STRINGLEN  ; descriptor address in AX 
	Ret

Err_Exit::                      ; MAIN ERROR EXIT
	Mov     AX, OFFSET B$STRINGLEN  ; put address of
	Push    AX              ; descriptor in AX
	Call    B$STDL          ; make it a null string
	Xor	AX,AX		; clear descriptor too
	Mov	B$STRINGLEN,AX	; necessary only for MASM created strings
	Mov	B$STRINGOFF,AX
	Jmp     Short Finis
FORMATNUM ENDP
END

