; created 11/30/91
; updated 05/20/92
; revised 08/05/93
;	to fix errors w/ TSR

;=======================================================================
;   Copyright (C) Copr. 1991, 1992, 1993  by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
; RM120TS8,16,24,32,40,48

DOSSEG
.MODEL MEDIUM, BASIC

BIOSRAM SEGMENT AT 0            ;make ASSUMEs more readable
BIOSRAM ENDS

ROM SEGMENT AT 0FFFFh
ROM ENDS

	Public B$KBD_Inst, B$KBD_Type

.DATA
	B$KBD_Inst  db    0     ; indicate routine installed
	B$KBD_Type  db    0     ; assume have normal keyboard
.CODE
; Please do not remove
;Copyright       DB    13,10,'Copyright Copr. (C) 1991, 1992, 1993 Sidney J. Kelly',13,10
;Copyright1      DB    'All Rights Reserved',13,10,26

;=======================================================================
; Routine tests to see if 101 Keyboard is installed
; 101KB supported on IBM AT w/ bios 11/15/85 and later
;                    IBM PC XT w/ bios 1/10/86 and later
;                    IBM XT 286 and all PS/2's
; This complicated effort is to: (1) overcome error of Early Wyse keyboard
; which falsely report to BIOS as having an 101 keyboard in
; at 0000:0496h bit 4, (According to QBASIC bugs list); (2)
; overcome problem with some BIOS that do NOT set 101kb bit if
; a key were stuck during POST or an extension keyboard was
; attached to main keyboard; and (3) cranky TSR's that grab Int 16h.
; (e.g. my circa 1988 DOS spelling checker) but in a fashion ignorant
; of extended keyboard, so TSR does not properly set ZF.
;
; Tested on old IBM PC (1982 bios), no errors
;=======================================================================

EVEN
B$CHK_KB PROC FAR BASIC USES AX DX ES
	Assume DS:@data		; this had better be true
	Xor     AX,AX
	Mov     ES,AX		; point ES to BIOS ram
	Assume  ES:NOTHING	; tell MASM
	Mov     AX,1200h	; read current shift status
	Int     16h		; (AL must be clear)
	Cmp     AL,Byte Ptr ES:[0417h]	; did I get back correct flags?
	Jne     Finis		; report not found
	Mov     DL,AL		; store flag status in DL
	Xor     Byte Ptr ES:[0417h],80h	; toggle insert bit
	Mov     AH,12h
	Int     16h		; read shift status again
	Xor     Byte Ptr ES:[0417h],80h	; toggle insert bit back
	Cmp     AL,DL		; did status change?
	JE      Finis		; if no change, exit
Got_it:
	Mov     AL,10h
	Mov     B$KBD_Type,AL	; note have extended kbd w/ bios support
Finis:
	Mov     AL,10h		; load installed value
	Mov     B$KBD_Inst,AL   ; note installed
	Ret
B$CHK_KB ENDP
END

; older routine, still not perfect
B$CHK_KB PROC FAR BASIC USES AX BX ES
;	Must be careful with the following since the Function 0C0h can 
;	crash old clones such as the AT&T 6300, (but not newer 6300 Plus).
;       This function will tell us if the BIOS supports the insert
;	keystroke function
	Mov     AX,0C000h       ; only new AT and XT2 bios support function
	CLC                     ; make sure carry flag is clear
	Int     15h             ; (AT&T 6300 bios error is the failure to
	STI                     ; reset interrupts after calling Int 15h)
	JC      Finis           ; if carry set then error, so no bios support
	OR      AH,AH           ; is AH = 0?
	; old PC bios returns 80h in AH, while XT bios returns 86h
	Jnz     Finis           ; if AH <>  0 then have old bios, so quit
	Mov	AL,ES:[BX+5]	; get information byte
	And	AL,10h		; is bit 4 set?
	Jz	Finis		; no, keyboard intercept not available
	; try an extended keyboard function in an effort to
	; test for 101 Key KB in case a stuck key during POST prevented
	; information bit from being set.
	; Initial assumption is have normal 83/84 key keyboard
Clear_Kbd:
	; very fast but non-compatible with TANDY 1000 series
	; not important here because of above testing
	Xor     AX,AX           ; very fast, no keys to read
	Mov     ES,AX
        ASSUME  ES:NOTHING      ; ES = BIOSRAM, remind programmer
	CLI                     ; prevent interrupts temporarily
	Mov     AL,ES:[041Ch]   ; Refer to actual addresses
	Mov     ES:[041Ah],AL   ; reset pointer in circular buffer to 0
	Mov     CX,-1		; load an impossible keystroke into buffer
	Mov     AX,500h		; load buffer (want it to be first key)
	Int     16h
	STI                     ; allow interrupts again
	JC      Finis           ; error occurred if carry set
	Cmp	AL,1		; buffer full?
	Je	Finis		; buffer was full, so quit
	; function not supported or buffer was full
	Mov     CX,16           ; test 16 times if necessary
Test_4_Key:
	Mov	AH,11h		; check if any key there
	Int	16h
	Jnz	@f		; if not zero, got a key
	Loop	Test_4_Key	; else, look some more
	Jmp     Short Finis     ; if 16 loops w/o success, report failure
@@:
	Mov     AH,10h
	Int     16h             ; read character back (waits until gets one)
	; certain TSR's will cause this section to stall
	Cmp     AX,-1		; is it the same key we stuffed?
	Je      Got_it          ; yes, got a 101kb
	Loop    Test_4_Key      ; if CX <> 0, re loop
	Jmp     Short Finis     ; else 16 loops w/o success, report failure
Got_it:
	Mov     AL,10h
	Mov     B$KBD_Type,AL   ; note have extended kbd w/ bios support
Finis:
	Mov     AL,10h          ; load installed value
	Mov     B$KBD_Inst,AL   ; note installed
	Ret
B$CHK_KB ENDP


