; Created 09/01/90
; Updated 12/19/92

;======================================================================
;   Copyright (C) Copr. 1990, 1991, 1992 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;======================================================================
;RM120TS8,16,24,32,40

;Preserves All registers but BX
;Assumes that neither DS nor ES point to DGROUP

Mouse_Off          Macro
      Local NotFound
	Cmp     SS:[B$MOUSEON],0        ; is mouse cursor on?
	Je      NotFound                ; nope, so quit
	Mov     BX,AX                   ; save AX in BX
	Mov     AX,2                    ; turn off mouse
	Int     33h
	Mov     AX,BX                   ; restore AX
	Mov     SS:[B$MOUSETOGL],1      ; report mouse switched
	Mov     SS:[B$MOUSEON],0        ; and no longer visible
NotFound:
	endm

;Preserves All registers but BX
;Assumes that neither DS nor ES point to DGROUP
Mouse_On           Macro
  Local     NotFound
	Cmp     SS:[B$MOUSETOGL],1      ; has mouse cursor been toggled
	JNE     NotFound                ; nope, so quit
	Mov     BX,AX                   ; save AX in BX
	Mov     AX,1                    ; turn on mouse
	Int     33h
	Mov     AX,BX                   ; restore AX
	Mov     SS:[B$MOUSETOGL],0      ; report mouse switched back
	Mov     SS:[B$MOUSEON],1        ; and visible again
NotFound:
	endm


DOSSEG
.MODEL MEDIUM, BASIC

EXTRN   Get_Adapter:FAR   ;determines video type

.DATA
	;external data so all video routines can access
	INCLUDE VDATA.INC
.CODE

BIOSRAM SEGMENT  AT 0         ; make ASSUME's more descriptive
BIOSRAM ENDS

INCLUDE NOWAIT.INC

; Please do not remove
;Copyright       DB    13,10,'Copyright Copr. (C) 1990, 1991, 1992  Sidney J. Kelly',13,10
;Copyright1      DB    'All Rights Reserved',13,10,26

;============================================================================
; M$PRINT - performs Quick Printing in MASM routines
; DECLARE SUB M$PRINT (ROW%, COL%, SEGM%, OFFS%, SLENGTH%, ATTRB%)
; Works in TextMode only, ignores all special characters
; Sensitive to all video modes (i.e. no snow on CGA's)
; If no attribute is selected, the default attribute is &H07 (normal)
; Assumes: Display width is 80 columns, Rows are 25, 43, or 50
;
; DOES NOT CHECK ROW, COL INPUT TO DETERMINE IF W/IN RANGE
;============================================================================

comment |
     Register usage when all done:
     AH = Color attribute for printing entire string.
     AL = temporarily holds the character to print.
     BX = trashed by Get_Adapter, not used later
     CX = SLENGTH of Text string.
     DX = Port for CGA video retrace check, if necessary.
	  0 means display is not a not a CGA display
     DS = Adjusted to point to Text string.
     SI = Offset of Text String
     ES = Segment of Video display, 0xB000 or 0xB800
     DI = Offset of Screen for current character
     |

EVEN
Doit:        ; save a jump in normal scenario
	Call    Get_Adapter  ;call routine to find display type
	Jmp     Short Main
EVEN
M$PRINT PROC FAR BASIC USES DS ES SI DI, ROW:Word, COLL:Word, \
ADDRESS:DWORD, SLENGTH:Word, ATTRIB:Word

	Assume  DS:NOTHING, ES:NOTHING
	Mouse_Off             ; shut off mouse if on MACRO
	Cmp   SS:[B$DVIDEOINSTL],1 ;See if we have done this before
	JNE   Doit            ;no, so determine type of display
Main:
	Mov   DL,Byte Ptr COLL;read value of COLL (BYVAL)
	Dec   DL              ;convert to BIOS format
	Mov   DH,Byte Ptr ROW ;read value of ROW (BYVAL)
	Dec   DH              ;convert to BIOS format
	CALL Near Ptr SET_DI  ;call routine to find video seg offset in DI
	LES   DX,DWORD PTR SS:[B$DVIDEOPORT] ;restore the initialized values
	Mov   AL,Byte Ptr ATTRIB ;get the color ATTRIBUTE% (BYVAL)
	Mov   AH,07        ;default use black backgnd, white letters
	Or    AL,AL        ;Is attribute > &H00? (0x00)
	Jz    @f           ;no, so use default & so jump ahead
	Mov   AH,AL        ;else, store ATTRIBUTE% in AH
@@:
	LDS   SI,ADDRESS   ; get segment and offset of string in DS:SI
	Mov   CX,SLENGTH    ; put length in CX
	JCXZ  Exit         ;if CX is zero it's a null string, exit now
	Or    DX,DX        ;are we on a mono or EGA system (is DX = 0)?
	JNZ   CGA          ;no, use CGA w/ retrace stuff
EVEN
Mono:
	Lodsb              ;get character from TEXT$ (DS:SI) and increment SI
	Stosw              ;store both character and attribute at ES:DI
	Loop  Mono         ;loop until CX is zero
Exit:
	Mov   SS:[B$DVIDEODI],DI ;save current DI
	Mouse_On            ;turn Mouse cursor on if on MACRO
	Ret                 ;return skipping the passed parameters
EVEN
CGA:
	CLI                ;prevent interrupts to speed routine
	Wait_CGA_Retrace   ;wait for CGA retrace MACRO (Destroys AL)
	Lodsb              ;get character from TEXT$ (DS:SI) and increment SI
	Stosw              ;store both character and attribute at ES:DI
	STI                ;allow interrupts again
	Loop  CGA          ;loop until CX is zero
	Mov   SS:[B$DVIDEODI],DI ;save current DI
	Mouse_On            ;turn Mouse cursor on if on MACRO
	Ret                 ;return skipping the passed parameters
M$PRINT  Endp

;============================================================================
; M$PRT - performs Quick Printing for MASM routines
; DECLARE SUB M$PRT (ROW%, COL%, SEGM%, OFFS%, SLENGTH%)
; Works in TextMode only, ignores all special characters
; Sensitive to all video modes (i.e. no snow on CGA's)
; Does not change the attribute, uses whatever was there.
;
; Assumes: Display width is 80 columns, Max Rows are 25, 43, or 50
;
; DOES NOT CHECK ROW, COL INPUT TO DETERMINE IF W/IN RANGE
;============================================================================
EVEN
Doit1:                        ; save a jump in normal case
	Call  Get_Adapter     ;call routine to find display type
	Jmp   Short Main1
EVEN
M$PRT PROC FAR BASIC USES DS ES SI DI, ROW:WORD, COLL:WORD, \
ADDRESS:DWORD, SLENGTH:WORD

	Assume        DS:NOTHING, ES:NOTHING
	Mouse_Off             ; shut off mouse if on MACRO
	Cmp   SS:[B$DVIDEOINSTL],1 ;See if we have done this before
	JNE   Doit1           ;no, so calc variables and return
Main1:
	Mov   DL,Byte Ptr COLL  ;read value of COLL (BYVAL)
	Dec   DL              ;convert to BIOS format, a 0 wd become &HFFFF
	Mov   DH,Byte Ptr ROW ;read value of ROW (BYVAL)
	Dec   DH              ;convert to BIOS format
	CALL Near Ptr SET_DI  ;call routine to find video seg offset in DI
	LES   DX,DWORD PTR SS:[B$DVIDEOPORT] ; restore the initialized values
	LDS   SI,ADDRESS   ; get segment and offset of string in DS:SI
	Mov   CX,SLENGTH    ; put length in CX
	JCXZ  Exit1        ;if CX is zero it's a null string, exit now
	Cld                ;clear the direction flag to move data forward
	OR    DX,DX        ;are we on a mono or EGA system (is DX = 0)?
	JNZ   CGA1         ;No, use retrace stuff
EVEN                       ; speeds loop
Mono1:
	;Lodsb              ;get TEXT$(DS:SI) character in AL, increment SI
	;Stosb              ;store just character but not attribute (ES:DI)
	Movsb              ;moves a byte from DS:SI to ES:DI
	Inc    DI          ;skip to next cell
	Loop   Mono1       ;loop until CX is zero
Exit1:
	Mov  SS:[B$DVIDEODI],DI ;save current DI
	Mouse_On           ;turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
EVEN                       ; speeds loop
CGA1:
	CLI                ;prevent interrupts to speed routine
	Wait_CGA_Retrace   ;wait for CGA retrace MACRO (destroys AL)
	;Lodsb              ;get TEXT$(DS:SI) character in AL, increment SI
	;Stosb              ;store just character but not attribute (ES:DI)
	Movsb              ;moves a byte from DS:SI to ES:DI
	STI                ;allow interrupts again
	Inc    DI          ;skip to next cell
	Loop   CGA1        ;loop until CX is zero
	Mov  SS:[B$DVIDEODI],DI ;save current DI
	Mouse_On           ;turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
M$PRT    Endp

;=============================================================================
;Call SET_DI
; A local subroutine that fixes DI
; Subroutine rather than a MACRO to save space in .OBJ file
;
; Setup for 80 column display because that is all QBASIC supports
;
; Input:     DH = Row :  DL = Column
; Output:    DI = Memory Offset
; Destroys:  CX
; A local routine is used so that the name will not become public and 
; and take up space in the .OBJ file
;=============================================================================

EVEN
SET_DI Label Near
	Set_DI_Offset      ; call MACRO to find video seg offset in DI
	Retn                   ; make a near return
END

