; created 04/19/93
; updated 04/19/93
;
;======================================================================
;   Copyright (C) Copr. 1993 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;======================================================================
;RM120TS8,16,24,32,40

DOSSEG
.MODEL MEDIUM, BASIC
.CODE

;======================================================================
; DECLARE FUNCTION VGAFIXTEXT% ()
; Purpose:
;       Prevents programmer from being confused by having a
;        VGA Color display in BIOS MODE 7 or a
;        VGA Mono display in BIOS MODE 3
; Returns:
;       1 if VGA Color in MODE 7
;       2 if VGA Mono  in Mode 3
;======================================================================

EVEN
VGAFIXTEXT PROC FAR BASIC
	Mov     AX,1A00h
	Mov     BX,10h          ; Test for VGA adapter
	Push    BP              ; prevent bios error
	Int     10h
	Pop     BP
	Cmp     AL,1Ah          ; If VGA adapter exists, it returns AL=1Ah
	Jne     Finis           ; VGA does not exist or not active, so quit
	Cmp     BL,8            ; routine returns primary display in BL
	Jne     VGA_Mono
VGA_Color:
	Mov     DX,3CCh         ; read misc register
	In      AL,DX           ; get byte
	Test    AL,1            ; test bit 0
	Jnz     Finis           ; if not zero, operating in color mode, o.k.
	Mov     AX,1
	Ret                     ; back to basic
VGA_Mono:
	Cmp     BL,7            ; is this a mono?
	Jne     Finis           ; no, so quit
	Mov     DX,3CCh         ; read misc register
	In      AL,DX           ; get byte
	Test    AL,1            ; test bit 0
	Jz      Finis           ; if zero, operating in mono mode, o.k.
	Mov     AX,2
	Ret                     ; back to basic
Finis:
	Xor     AX,AX
	Ret
VGAFIXTEXT ENDP
END

